    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------
    028     * KeyedValues.java
    029     * ----------------
    030     * (C) Copyright 2002-2006, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: KeyedValues.java,v 1.3.2.3 2006/11/24 10:27:33 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 23-Oct-2002 : Version 1 (DG);
    040     * 12-Jan-2005 : Updated Javadocs to specify new behaviour when key
    041     *               is not recognised (DG);
    042     * ------------- JFREECHART 1.0.0 ---------------------------------------------
    043     * 02-May-2006 : Updated API docs (DG);
    044     *
    045     */
    046
    047    package org.jfree.data;
    048
    049    import java.util.List;
    050
    051    /**
    052     * An ordered list of (key, value) items where the keys are unique and
    053     * non-<code>null</code>.
    054     *
    055     * @see Values
    056     * @see DefaultKeyedValues
    057     */
    058    public interface KeyedValues extends Values {
    059
    060        /**
    061         * Returns the key associated with the item at a given position.  Note
    062         * that some implementations allow re-ordering of the data items, so the
    063         * result may be transient.
    064         *
    065         * @param index  the item index (in the range <code>0</code> to
    066         *     <code>getItemCount() - 1</code>).
    067         *
    068         * @return The key (never <code>null</code>).
    069         *
    070         * @throws IndexOutOfBoundsException if <code>index</code> is not in the
    071         *     specified range.
    072         */
    073        public Comparable getKey(int index);
    074
    075        /**
    076         * Returns the index for a given key.
    077         *
    078         * @param key  the key (<code>null</code> not permitted).
    079         *
    080         * @return The index, or <code>-1</code> if the key is unrecognised.
    081         *
    082         * @throws IllegalArgumentException if <code>key</code> is
    083         *     <code>null</code>.
    084         */
    085        public int getIndex(Comparable key);
    086
    087        /**
    088         * Returns the keys for the values in the collection.  Note that you can
    089         * access the values in this collection by key or by index.  For this
    090         * reason, the key order is important - this method should return the keys
    091         * in order.  The returned list may be unmodifiable.
    092         *
    093         * @return The keys (never <code>null</code>).
    094         */
    095        public List getKeys();
    096
    097        /**
    098         * Returns the value for a given key.
    099         *
    100         * @param key  the key.
    101         *
    102         * @return The value (possibly <code>null</code>).
    103         *
    104         * @throws UnknownKeyException if the key is not recognised.
    105         */
    106        public Number getValue(Comparable key);
    107
    108    }